﻿class Control extends MovieClip {
	//MovieClips
	private var mapArea_mc:MovieClip;
	private var roomCeil_mc:MovieClip;
	private var roomContent_mc:MovieClip;
	private var ceil_mc:MovieClip;
	private var wall_mc:MovieClip;
	private var stuff_mc:MovieClip;
	//Content Names
	private var ceil:String = Default.ceil;
	private var wall:String = Default.wall;
	private var stuff:String = Default.stuff;
	private var stuffLib:String = Default.stuffLib;
	private var deleteCeil:String = Default.deleteCeil;
	//Classes
	private var myMap:Map;
	private var myDataStore:DataStore;
	private var myPathFinder:PathFinder;
	private var myUndo:Undo;
	//Default Values
	private var row:Number = Default.row;
	private var col:Number = Default.col;
	private var w:Number = Default.w;
	private var h:Number = Default.h;
	private var tempWidth:Number;
	//Boolean variables
	private var isDeleteWall:Boolean = false;
	private var isDeleteStuff:Boolean = false;
	//Depth araligi
	private var depther:Number = Default.depther;
	//Max stuff Len
	private var maxStuffLen:Number = Default.maxStuffLen;
	function Control(m, mc1, mc2, mc3) {
		myMap = m;
		mapArea_mc = mc1;
		roomCeil_mc = mc2;
		roomContent_mc = mc3;
		tempWidth = col*h;
		myPathFinder = new PathFinder(m);
		myDataStore = new DataStore();
		myUndo = new Undo(m, this);
	}
	//Undo Functions
	function back(Void):Void {
		myUndo.back();
	}
	function forward(Void):Void {
		myUndo.forward();
	}
	//Attach Functions
	function attachCeil(index:Number):Void {
		if (index != 0) {
			ceil_mc = roomCeil_mc.attachMovie(ceil+index, ceil, 100001, {_x:0, _y:0});
		} else {
			ceil_mc = roomCeil_mc.attachMovie(deleteCeil, ceil, 100001, {_x:0, _y:0});
		}
		ceil_mc.pressOb = {x:Number, y:Number};
		ceil_mc.oldOb = {x:Number, y:Number};
		ceil_mc.isPress = false;
		ceil_mc.tempWidth = tempWidth;
		ceil_mc.h = h;
		ceil_mc.w = w;
		ceil_mc.row = row;
		ceil_mc.corX = 0;
		ceil_mc.corY = 0;
		ceil_mc.index = index;
		ceil_mc.ceil = ceil;
		ceil_mc.depther = depther;
		ceil_mc.myMap = myMap;
		ceil_mc.onMouseMove = function() {
			this.corX = Math.floor((_parent._xmouse+2*_parent._ymouse+this.tempWidth*2)/(this.h*2));
			this.corY = Math.floor((-_parent._xmouse+2*_parent._ymouse+this.tempWidth*2)/(this.h*2));
			//trace("x: "+corX+ " y: "+corY+  " _parent._xmouse "+_parent._parent._parent._xmouse);
			if ((this.myMap.ceilMatrix[this.corY][this.corX] != undefined)) {
				this._x = (this.corX-this.corY)*this.h;
				this._y = (this.corX+this.corY)*this.h/2-(this.tempWidth-this.h);
				if (this.isPress) {
					if ((this.oldOb.x != this.corX) || (this.oldOb.y != this.corY)) {
						if ((this.corX>=this.oldOb.x) && (this.corY>=this.oldOb.y)) {
							for (var i = this.pressOb.y; i<=this.corY; i++) {
								for (var j = this.oldOb.x; j<=this.corX; j++) {
									var dep:Number = i*this.row+j+1;
									var tmpX:Number = (j-i)*this.h;
									var tmpY:Number = (i+j)*this.h/2-(this.tempWidth-this.h);
									myMap.changeCeilMatrix(i, j, this.index);
									_parent.attachMovie(ceil+index, ceil+dep, dep*this.depther, {_x:tmpX, _y:tmpY});
								}
							}
							for (var j = this.pressOb.x; j<=this.corX; j++) {
								for (var i = this.oldOb.y; i<=this.corY; i++) {
									var dep:Number = i*this.row+j+1;
									var tmpX:Number = (j-i)*this.h;
									var tmpY:Number = (i+j)*this.h/2-(this.tempWidth-this.h);
									myMap.changeCeilMatrix(i, j, this.index);
									_parent.attachMovie(ceil+index, ceil+dep, dep*this.depther, {_x:tmpX, _y:tmpY});
								}
							}
						} else if ((this.corX<=this.oldOb.x) && (this.corY<=this.oldOb.y)) {
							for (var i = this.corY; i<=this.pressOb.y; i++) {
								for (var j = this.corX; j<=this.oldOb.x; j++) {
									var dep:Number = i*this.row+j+1;
									var tmpX:Number = (j-i)*this.h;
									var tmpY:Number = (i+j)*this.h/2-(this.tempWidth-this.h);
									myMap.changeCeilMatrix(i, j, this.index);
									_parent.attachMovie(ceil+index, ceil+dep, dep*this.depther, {_x:tmpX, _y:tmpY});
								}
							}
							for (var j = this.corX; j<=this.pressOb.x; j++) {
								for (var i = this.corY; i<=this.oldOb.y; i++) {
									var dep:Number = i*this.row+j+1;
									var tmpX:Number = (j-i)*this.h;
									var tmpY:Number = (i+j)*this.h/2-(this.tempWidth-this.h);
									myMap.changeCeilMatrix(i, j, this.index);
									_parent.attachMovie(ceil+index, ceil+dep, dep*this.depther, {_x:tmpX, _y:tmpY});
								}
							}
						}
					}
					this.oldOb.x = this.corX;
					this.oldOb.y = this.corY;
				}
			}
		};
		ceil_mc.useHandCursor = false;
		ceil_mc.onPress = function() {
			this.isPress = true;
			this.pressOb.x = this.corX;
			this.pressOb.y = this.corY;
			this.oldOb.x = this.corX;
			this.oldOb.y = this.corY;
			//atatching a grid
			var dep:Number = this.corY*this.row+this.corX+1;
			var tmpX:Number = (this.corX-this.corY)*this.h;
			var tmpY:Number = (this.corY+this.corX)*this.h/2-(this.tempWidth-this.h);
			myMap.changeCeilMatrix(this.corY, this.corX, this.index);
			_parent.attachMovie(ceil+index, ceil+dep, dep*this.depther, {_x:tmpX, _y:tmpY});
		};
		ceil_mc.onRelease = function() {
			this.isPress = false;
		};
		ceil_mc.onReleaseOutside = function() {
			this.isPress = false;
		};
	}
	function attachWall(index:Number):Void {
		clearAll();
		wall_mc = roomContent_mc.attachMovie(wall+index, wall, 100002, {_x:0, _y:0});
		wall_mc.gotoAndStop(2);
		//Properties
		wall_mc.pressOb = {x:Number=0, y:Number=0};
		wall_mc.oldOb = {x:Number=0, y:Number=0};
		wall_mc.oldPathObj = {};
		wall_mc.isPress = false;
		wall_mc.tempWidth = tempWidth;
		wall_mc.h = h;
		wall_mc.w = w;
		wall_mc.row = row;
		wall_mc.corX = 0;
		wall_mc.corY = 0;
		wall_mc.index = index;
		wall_mc.wall = wall;
		wall_mc.depther = depther;
		wall_mc.myPathFinder = myPathFinder;
		wall_mc.myMap = myMap;
		wall_mc.wallMin = Default.wallsSpace.min;
		wall_mc.onMouseMove = function() {
			this.corX = Math.floor((_parent._xmouse+2*_parent._ymouse+this.tempWidth*2)/(this.h*2));
			this.corY = Math.floor((-_parent._xmouse+2*_parent._ymouse+this.tempWidth*2)/(this.h*2));
			if ((this.myMap.contentBooleanMatrix[this.corY][this.corX]) && (this.myMap.contentMatrix[this.corY][this.corX] != undefined)) {
				this._x = (this.corX-this.corY)*this.h;
				this._y = (this.corX+this.corY)*this.h/2-(this.tempWidth-this.h);
				var dep:Number = this.corY*this.row+this.corX+1;
				this.swapDepths((dep*this.depther-1));
				if (this.isPress) {
					if ((this.corX != this.oldOb.x) || (this.corY != this.oldOb.y)) {
						var pathObj:Object;
						pathObj = this.myPathFinder.findPath({x:this.pressOb.x, y:this.pressOb.y}, {x:this.corX, y:this.corY});
						var len:Number = pathObj.xPath.length;
						//clearing old one
						if (this.oldPathObj.weight>0) {
							for (var i = 0; i<this.oldPathObj.xPath.length; i++) {
								var dep:Number = this.oldPathObj.yPath[i]*this.row+this.oldPathObj.xPath[i]+1;
								if (_parent[wall+dep]) {
									this.myMap.changeContentMatrix(this.oldPathObj.yPath[i], this.oldPathObj.xPath[i], 0);
									_parent[wall+dep].removeMovieClip();
								}
							}
						}
						for (var i = 0; i<len; i++) {
							var x1:Number = pathObj.xPath[i];
							var y1:Number = pathObj.yPath[i];
							if (this.myMap.contentBooleanMatrix[y1][x1]) {
								var dep:Number = y1*this.row+x1+1;
								var tmpX:Number = (x1-y1)*this.h;
								var tmpY:Number = (y1+x1)*this.h/2-(this.tempWidth-this.h);
								var mc:MovieClip = _parent.attachMovie(wall+index, wall+dep, dep*this.depther, {_x:tmpX, _y:tmpY});
								var direction:Number = 1;
								mc.gotoAndStop(direction+1);
							}
						}
						this.oldPathObj = pathObj;
					}
				}
				this.oldOb.x = this.corX;
				this.oldOb.y = this.corY;
			}
		};
		wall_mc.useHandCursor = false;
		wall_mc.onPress = function() {
			this.isPress = true;
			this.pressOb.x = this.corX;
			this.pressOb.y = this.corY;
			this.oldOb.x = this.corX;
			this.oldOb.y = this.corY;
			this.oldPathObj.weight = 0;
			//atatching a grid
			if (this.myMap.contentBooleanMatrix[this.corY][this.corX]) {
				var dep:Number = this.corY*this.row+this.corX+1;
				var tmpX:Number = (this.corX-this.corY)*this.h;
				var tmpY:Number = (this.corX+this.corY)*this.h/2-(this.tempWidth-this.h);
				myMap.changeContentMatrix(this.corY, this.corX, (this.index+this.wallMin));
				var mc:MovieClip = _parent.attachMovie(wall+index, wall+dep, dep*this.depther, {_x:tmpX, _y:tmpY});
				mc.gotoAndStop(2);
			}
		};
		wall_mc.onRelease = function() {
			this.isPress = false;
			var len:Number = this.oldPathObj.yPath.length;
			if (len != undefined) {
				for (var i = 0; i<=len; i++) {
					this.myMap.changeContentMatrix(this.oldPathObj.yPath[i], this.oldPathObj.xPath[i], (this.index+this.wallMin));
				}
			}
			//this.myMap.traceContentMatrix();
			//this.myMap.traceContentBooleanMatrix();
			//this.myPathFinder.traceContentBooleanMatrix();
		};
		wall_mc.onReleaseOutside = function() {
			this.isPress = false;
			var len:Number = this.oldPathObj.yPath.length;
			if (len != undefined) {
				var len:Number = this.oldPathObj.yPath.length;
				for (var i = 0; i<=len; i++) {
					this.myMap.changeContentMatrix(this.oldPathObj.yPath[i], this.oldPathObj.xPath[i], (this.index+this.wallMin));
				}
			}
			//this.myPathFinder.traceContentBooleanMatrix();
			//this.myMap.traceContentMatrix();
		};
	}
	function deleteWall(Void):Void {
		clearAll();
		wall_mc = roomContent_mc.attachMovie(wall+0, wall, 100002, {_x:0, _y:0});
		wall_mc.gotoAndStop(2);
		Mouse.hide();
		//Properties
		//Properties
		wall_mc.onEnterFrame = function() {
			this._x = _parent._xmouse;
			this._y = _parent._ymouse;
		};
		//attaching
		isDeleteWall = true;
		for (var each in roomContent_mc) {
			var obj = roomContent_mc[each];
			if (obj instanceof Wall) {
				obj.myMap = myMap;
				obj.tempWidth = tempWidth;
				obj.h = h;
				obj.onPress = function() {
					var x:Number = Math.floor((this._x+2*this._y+this.tempWidth*2)/(this.h*2));
					var y:Number = Math.floor((-this._x+2*this._y+this.tempWidth*2)/(this.h*2));
					//trace("x: "+x+" y: "+y);
					this.myMap.changeContentMatrix((y-1), (x-1), 0);
					this.removeMovieClip();
				};
			}
		}
	}
	function attachStuff(obj:Object):Void {
		//Getting values
		var index:Number = obj.value;
		//Clearing
		clearAll();
		//Attaching
		stuff_mc = roomContent_mc.attachMovie(stuff+index, stuff, 100003, {_x:0, _y:0});
		stuff_mc.gotoAndStop(2);
		//Properties
		stuff_mc.oldObj = {x:Number=0, y:Number=0};
		stuff_mc.obj = obj;
		stuff_mc.matrix = obj.matrix1;
		stuff_mc.isPress = false;
		stuff_mc.tempWidth = tempWidth;
		stuff_mc.h = h;
		stuff_mc.w = w;
		stuff_mc.row = row;
		stuff_mc.corX = 0;
		stuff_mc.corY = 0;
		stuff_mc.index = index;
		stuff_mc.stuff = stuff;
		stuff_mc.stuffLib = stuffLib;
		stuff_mc.depther = depther;
		stuff_mc.myMap = myMap;
		stuff_mc.myDataStore = myDataStore;
		//Listener for rotate
		stuff_mc.dir = 2;
		stuff_mc.myListener1 = {};
		stuff_mc.myListener1.dir = 2;
		stuff_mc.myListener1.stuff_mc = stuff_mc;
		stuff_mc.myListener1.onKeyDown = function() {
			if (Key.getCode() == 82) {
				this.dir++;
				if (this.dir == 6) {
					this.dir = 2;
				}
				this.stuff_mc.gotoAndStop(this.dir);
				this.stuff_mc.dir = this.dir;
				if (this.dir == 2) {
					this.stuff_mc.matrix = this.stuff_mc.obj.matrix1;
				} else if (this.dir == 3) {
					this.stuff_mc.matrix = this.stuff_mc.obj.matrix2;
				} else if (this.dir == 4) {
					this.stuff_mc.matrix = this.stuff_mc.obj.matrix3;
				} else {
					this.stuff_mc.matrix = this.stuff_mc.obj.matrix4;
				}
			}
		};
		Key.addListener(stuff_mc.myListener1);
		stuff_mc.onMouseMove = function() {
			this.corX = Math.floor((_parent._xmouse+2*_parent._ymouse+this.tempWidth*2)/(this.h*2));
			this.corY = Math.floor((-_parent._xmouse+2*_parent._ymouse+this.tempWidth*2)/(this.h*2));
			//trace("x: "+corX+ " y: "+corY+  " _parent._xmouse "+_parent._parent._parent._xmouse);
			//Seeking if i can fit the area
			var isFit:Boolean = true;
			//trace("matrix len: "+this.matrix.length);
			//trace("corY: "+this.corY+" corX: "+this.corX);
			for (var i = 0; i<this.matrix.length; i++) {
				for (var j = 0; j<this.matrix[0].length; j++) {
					if (!this.myMap.contentBooleanMatrix[this.corY-i][this.corX-j]) {
						isFit = false;
						break;
					}
				}
			}
			if (isFit && (this.myMap.contentMatrix[this.corY][this.corX] != undefined)) {
				this._x = (this.corX-this.corY)*this.h;
				this._y = (this.corX+this.corY)*this.h/2-(this.tempWidth-this.h);
				var dep:Number = this.corY*this.row+this.corX+1;
				this.swapDepths((dep*this.depther-1));
				this.oldObj.x = this.corX;
				this.oldObj.y = this.corY;
			}
		};
		stuff_mc.useHandCursor = false;
		stuff_mc.onPress = function() {
			this.isPress = true;
			//atatching a grid
			//Seeking if i can fit the area
			var isFit:Boolean = true;
			//trace("matrix len: "+this.matrix.length);
			for (var i = 0; i<this.matrix.length; i++) {
				for (var j = 0; j<this.matrix[0].length; j++) {
					if (!this.myMap.contentBooleanMatrix[this.oldObj.y-i][this.oldObj.x-j]) {
						isFit = false;
						break;
					}
				}
			}
			if (isFit) {
				this.attachStuff();
			}
		};
		stuff_mc.attachStuff = function(Void) {
			var tmpArray:Array = new Array();
			var xx:Number = 0;
			for (var i = 0; i<this.matrix.length; i++) {
				for (var j = 0; j<this.matrix[0].length; j++) {
					tmpArray[xx] = new Array();
					var no:Number = this.matrix[i][j];
					tmpArray[xx][0] = (this.oldObj.y-i);
					tmpArray[xx][1] = (this.oldObj.x-j);
					this.myMap.changeContentMatrix((this.oldObj.y-i), (this.oldObj.x-j), no);
					var dep:Number = (this.oldObj.y-i)*this.row+(this.oldObj.x-j)+1;
					var tmpX:Number = ((this.oldObj.x-j)-(this.oldObj.y-i))*this.h;
					var tmpY:Number = ((this.oldObj.x-j)+(this.oldObj.y-i))*this.h/2-(this.tempWidth-this.h);
					var mc:MovieClip = _parent.attachMovie(stuffLib+no, stuff+dep, dep*this.depther, {_x:tmpX, _y:tmpY});
					xx++;
				}
			}
			this.myMap.changeStuffMatrix(this.oldObj.x, this.oldObj.y, this.matrix);
			var no:Number = this.matrix[0][0];
			var tmpNumber:Number = no-(no%20);
			var tmpString:String = tmpNumber.toString();
			this.myDataStore.addStuff(tmpString, tmpArray);
			//this.myMap.traceContentMatrix();
		};
	}
	function deleteStuff(Void):Void {
		clearAll();
		stuff_mc = roomContent_mc.attachMovie(stuff+0, stuff, 100002, {_x:0, _y:0});
		stuff_mc.gotoAndStop(2);
		Mouse.hide();
		stuff_mc.onEnterFrame = function() {
			this._x = _parent._xmouse;
			this._y = _parent._ymouse;
		};
		//attaching
		isDeleteStuff = true;
		for (var each in roomContent_mc) {
			var obj = roomContent_mc[each];
			if (obj instanceof Stuff) {
				obj.control = this;
				obj.tempWidth = tempWidth;
				obj.h = this.h;
				obj.onPress = function() {
					var x:Number = Math.floor((this._x+2*this._y+this.tempWidth*2)/(this.h*2));
					var y:Number = Math.floor((-this._x+2*this._y+this.tempWidth*2)/(this.h*2));
					//trace("x: "+x+" y: "+y);
					this.control.removeStuff((y-1), (x-1));
				};
			}
		}
	}
	function removeStuff(x:Number, y:Number):Void {
		var matrix:Array = new Array();
		var beginX:Number;
		var beginY:Number = y;
		//trace("remove Stuff");
		//find the beginnig point
		/*
		for (var i = 0; i<maxStuffLen; i++) {
			var tmp1:Number = myMap.stuffMatrix[x+i][y];
			var tmp2:Number = myMap.stuffMatrix[x+i+1][y];
			if ((tmp1-tmp2) != 1) {
				break;
			}
		}
		beginX = x+i;
		for (var i = 0; i<maxStuffLen; i++) {
			var tmp1:Number = myMap.stuffMatrix[beginX-i][beginY];
			var tmp2:Number = myMap.stuffMatrix[beginX-i-1][beginY];
			if ((tmp2-tmp1) != 1) {
				break;
			}
		}
		*/
		
		for (var i = 0; i<maxStuffLen; i++) {
			var tmp1:Number = myMap.stuffMatrix[x+i][y];
			var tmp2:Number = myMap.stuffMatrix[x+i+1][y];
			if (tmp1 != tmp2) {
				break;
			}
		}
		beginX = x+i;
		for (var i = 0; i<maxStuffLen; i++) {
			var tmp1:Number = myMap.stuffMatrix[beginX-i][beginY];
			var tmp2:Number = myMap.stuffMatrix[beginX-i-1][beginY];
			if (tmp2 != tmp1) {
				break;
			}
		}
		
		for (var j = 0; j<=i; j++) {
			trace("control remove");
			var no:Number = row*(beginX-j)+beginY+1;
			roomContent_mc[stuff+no].removeMovieClip();
			this.myMap.removeStuff((beginX-j), beginY);
		}
	}
	function clearAll(Void):Void {
		ceil_mc.removeMovieClip();
		wall_mc.removeMovieClip();
		Key.removeListener(stuff_mc.myListener1);
		stuff_mc.removeMovieClip();
		if (isDeleteWall) {
			isDeleteWall = false;
			for (var each in roomContent_mc) {
				var obj = roomContent_mc[each];
				if (obj instanceof Wall) {
					delete obj.onPress;
				}
			}
		} else if (isDeleteStuff) {
			isDeleteStuff = false;
			for (var each in roomContent_mc) {
				var obj = roomContent_mc[each];
				if (obj instanceof Stuff) {
					delete obj.onPress;
				}
			}
		}
		Mouse.show();
	}
	//On Off functions
	public function onOffCeil(b:Boolean):Void {
		roomCeil_mc._visible = b;
	}
	public function onOffWall(b:Boolean):Void {
		for (var each in roomContent_mc) {
			var obj = roomContent_mc[each];
			if (obj instanceof Wall) {
				obj._visible = b;
			}
		}
	}
	public function onOffStuff(b:Boolean):Void {
		for (var each in roomContent_mc) {
			var obj = roomContent_mc[each];
			if (!(obj instanceof Wall)) {
				obj._visible = b;
			}
		}
	}
}
