﻿class PathFinder {
	private var map:Array;
	private var starting:Object;
	private var end:Object;
	private var depth:Number;
	//Classes
	private var myMap:Map;
	function PathFinder(fMap:Map) {
		myMap = fMap;
		map = myMap.contentBooleanMatrix;
		starting = {x:0, y:0};
		end = {x:0, y:0};
		depth = 200;
	}
	function findPath(starting_ar:Object, end_ar:Object):Object {
		starting = starting_ar;
		end = end_ar;
		var tmpPath:Object;
		//var $paths:Array = [];
		//get paths based on level:
		//$paths[0] = $findPath(starting, end, true, false);
		//$paths[1] = $findPath(starting, end, false, false);
		//$paths[2] = $findPath(end, starting, true, true);
		//$paths[3] = $findPath(end, starting, false, true);
		tmpPath = $findPath(starting, end, true, false);
		if (tmpPath.weight>1000) {
			tmpPath = $findPath(starting, end, false, false);
		} else if (tmpPath.weight>1000) {
			tmpPath = $findPath(end, starting, true, true);
		} else if (tmpPath.weight>1000) {
			tmpPath = $findPath(end, starting, false, true);
		}
		// sort on weight:
		//$paths.sort($pathSort);
		// set path and return it;
		//return $paths[0];
		return tmpPath;
	}
	private function $pathSort(fVal1:Object, fVal2:Object):Number {
		if (fVal1.weight<fVal2.weight) {
			return -1;
		} else if (fVal1.weight>fVal2.weight) {
			return 1;
		}
		return 0;
	}
	/*** PathFinder.$findPath
			searches for a path from start point to end point.
			dir is a boolean, and specifies the search direction (true = favour x, false = favour y)
			rev indicates whether the path should be reversed after it is found.
		***/
	private function $findPath(fStart:Object, fEnd:Object, fDir:Boolean, fRev:Boolean):Object {
		// set up:
		var curx:Number = fStart.x;
		var cury:Number = fStart.y;
		var pathWeight:Number = 0;
		var pathx:Array = [];
		var pathy:Array = [];
		var endx:Number = fEnd.x;
		var endy:Number = fEnd.y;
		var oldx:Number;
		var oldy:Number;
		// try to find a path:
		while (true) {
			if ((curx == pathx[pathWeight-4]) && (cury == pathy[pathWeight-4])) {
				pathWeight = 10000;
				break;
			}
			oldx = pathx[pathWeight-1];
			oldy = pathy[pathWeight-1];
			pathx.push(curx);
			pathy.push(cury);
			pathWeight++;
			if (endx == curx && endy == cury) {
				break;
			}
			if (pathWeight>depth) {
				pathWeight = 10000;
				break;
			}
			if (fDir) {
				// favour x movements
				// move towards end:
				if ((curx<endx) && (oldx != curx+1) && (map[cury][curx+1])) {
					curx++;
					continue;
				}
				if ((curx>endx) && (oldx != curx-1) && (map[cury][curx-1])) {
					curx--;
					continue;
				}
				if ((cury<endy) && (oldy != cury+1) && (map[cury+1][curx])) {
					cury++;
					continue;
				}
				if ((cury>endy) && (oldy != cury-1) && (map[cury-1][curx])) {
					cury--;
					continue;
				}
				// can't move towards try lateral:
				if (curx == endx) {
					if ((oldx != curx+1) && (map[cury][curx+1])) {
						curx++;
						continue;
					}
					if ((oldx != curx-1) && (map[cury][curx-1])) {
						curx--;
						continue;
					}
				} else if (cury == endy) {
					if ((oldy != cury+1) && (map[cury+1][curx])) {
						cury++;
						continue;
					}
					if ((oldy != cury-1) && (map[cury-1][curx])) {
						cury--;
						continue;
					}
				}
				// can't move lateral, try away:
				if ((curx>endx) && (oldx != curx+1) && (map[cury][curx+1])) {
					curx++;
					continue;
				} else if ((oldx != curx-1) && (map[cury][curx-1])) {
					curx--;
					continue;
				}
				if ((cury>endy) && (oldy != cury+1) && (map[cury+1][curx])) {
					cury++;
					continue;
				} else if ((oldy != cury-1) && (map[cury-1][curx])) {
					cury--;
					continue;
				}
			} else {
				// favour y movements
				// move towards end:
				if ((cury<endy) && (oldy != cury+1) && (map[cury+1][curx])) {
					cury++;
					continue;
				}
				if ((cury>endy) && (oldy != cury-1) && (map[cury-1][curx])) {
					cury--;
					continue;
				}
				if ((curx<endx) && (oldx != curx+1) && (map[cury][curx+1])) {
					curx++;
					continue;
				}
				if ((curx>endx) && (oldx != curx-1) && (map[cury][curx-1])) {
					curx--;
					continue;
				}
				// can't move towards try lateral:
				if (cury == endy) {
					if ((oldy != cury-1) && (map[curx][cury-1])) {
						cury--;
						continue;
					}
					if ((oldy != cury+1) && (map[curx][cury+1])) {
						cury++;
						continue;
					}
				} else if (curx == endx) {
					if ((oldx != curx-1) && (map[cury][curx-1])) {
						curx--;
						continue;
					}
					if ((oldx != curx+1) && (map[cury][curx+1])) {
						curx++;
						continue;
					}
				}
				// can't move laterally, try away:
				if ((cury<endy) && (oldy != cury-1) && (map[cury-1][curx])) {
					cury--;
					continue;
				} else if ((oldy != cury+1) && (map[cury+1][curx])) {
					cury++;
					continue;
				}
				if ((curx<endx) && (oldx != curx-1) && (map[cury][curx-1])) {
					curx--;
					continue;
				} else if ((oldx != curx+1) && (map[cury][curx+1])) {
					curx++;
					continue;
				}
			}
			// end if
			// darn, we're stuck.
			pathWeight = 10000;
			break;
		}
		// end while
		// flip the path if it is reversed, and if we were successful
		if (fRev && (pathWeight<10000)) {
			pathx.reverse();
			pathy.reverse();
		}
		return {xPath:pathx, yPath:pathy, weight:pathWeight};
	}
}
