﻿class World extends MovieClip {
	//MovieClips
	private var mapArea_mc:MovieClip;
	private var roomCeil_mc:MovieClip;
	private var roomContent_mc:MovieClip;
	private var navigation_mc:MovieClip;
	//MovieClips Linkage Names
	private var mapArea:String = Default.mapArea;
	private var roomCeil:String = Default.roomCeil;
	private var roomContent:String = Default.roomContent;
	private var navigation:String = Default.navigation;
	//Content Names
	private var ceil:String = Default.ceil;
	private var wall:String = Default.wall;
	private var stuff:String = Default.stuff;
	private var stuffLib:String = Default.stuffLib;
	//Position Cordinates
	private var navigationX:Number = Default.navigationX;
	private var navigationY:Number = Default.navigationY;
	private var mapAreaX:Number = Default.mapAreaX;
	private var mapAreaY:Number = Default.mapAreaY;
	//Default Values
	private var row:Number = Default.row;
	private var col:Number = Default.col;
	private var w:Number = Default.w;
	private var h:Number = Default.h;
	var tempWidth:Number;
	//Spaces
	private var wallsSpace:Object;
	private var stuffsSpace:Object;
	private var goodsSpace:Object;
	private var sitsSpace:Object;
	//Depth araligi
	private var depther:Number = Default.depther;
	//Classes
	private var myMap:Map;
	private var myControl:Control;
	private var myDefault:Default;
	//Listeners
	var myListener1:Object;
	function World() {
		//Defining Classes
		myMap = new Map();
		myDefault = new Default();
		//Initialize
		init();
		//MovieClips
		mapArea_mc = this.attachMovie(mapArea, mapArea, 2, {_x:mapAreaX, _y:mapAreaY});
		roomCeil_mc = mapArea_mc.attachMovie(roomCeil, roomCeil, 1, {_x:0, _y:tempWidth});
		roomContent_mc = mapArea_mc.attachMovie(roomContent, roomContent, 2, {_x:0, _y:tempWidth});
		myControl = new Control(myMap,  mapArea_mc, roomCeil_mc, roomContent_mc);
		navigation_mc = this.attachMovie(navigation, navigation, 1, {_x:navigationX, _y:navigationY, myControl:myControl});
		//myMap.traceCeilMatrix();
		//myMap.traceWallMatrix();
		//myMap.traceStuffMatrix();
		//Generating Map
		generateMapArea();
		addMyListener();
		//Other Classes
	}
	private function init(Void):Void {
		tempWidth = col*h;
		wallsSpace = Default.wallsSpace;
		stuffsSpace = Default.stuffsSpace;
		goodsSpace = Default.goodsSpace;
		sitsSpace = Default.sitsSpace;
	}
	private function addMyListener(Void):Void {
		//Listener 1
		myListener1 = new Object();
		myListener1.isClick1 = 0;
		myListener1.isClick2 = true;
		myListener1.world = this;
		myListener1.onKeyDown = function() {
			if (Key.isDown(Key.SPACE)) {
				var dir:Number;
				if (this.isClick1 == 0) {
					dir = 4;
					this.isClick1 = 1;
				} else if (this.isClick1 == 1) {
					dir = 3;
					this.isClick1 = 2;
				} else if (this.isClick1 == 2) {
					dir = 2;
					this.isClick1 = 0;
				}
				for (var each in this.world.roomContent_mc) {
					var obj = this.world.roomContent_mc[each];
					if (obj instanceof Wall) {
						obj.gotoAndStop(dir);
					}
				}
			} else if (Key.isDown(Key.CONTROL)) {
				var dir:Number;
				if (this.isClick2) {
					dir = 20;
				} else {
					dir = 100;
				}
				this.isClick2 = !this.isClick2;
				for (var each in this.world.roomContent_mc) {
					var obj = this.world.roomContent_mc[each];
					if (obj instanceof Wall) {
						obj._alpha = dir;
					}
				}
			} else if (Key.getCode() == 81) {
				//Q
				this.world.myControl.clearAll();
			} else if (Key.getCode() == 84) {
				//T
				this.world.myMap.traceContentMatrix();
			} else if (Key.getCode() == 83) {
				//S
				this.world.myMap.traceStuffMatrix();
			}
		};
		Key.addListener(myListener1);
		///////////////////////
	}
	private function generateMapArea(Void):Void {
		var n:Number = 0;
		var index:Number = 0;
		var tp:MovieClip;
		//ceil mc
		for (var x = 0; x<row; x++) {
			for (var y = 0; y<col; y++) {
				n++;
				index = myMap.ceilMatrix[x][y];
				if (index>0) {
					tp = roomCeil_mc.attachMovie(ceil+index, ceil+n, n*depther);
					tp._x = (y-x)*(w)/2;
					tp._y = (x+y)*(h)/2-(tempWidth-h);
				}
			}
		}
		//conetent mc
		n = 0;
		for (x=0; x<row; x++) {
			for (y=0; y<col; y++) {
				n++;
				index = myMap.contentMatrix[x][y];
				var wallMin:Number = wallsSpace.min;
				var wallMax:Number = wallsSpace.max;
				var stuffMin:Number = stuffsSpace.min;
				var stuffMax:Number = stuffsSpace.max;
				if ((index>wallMin) && (index<wallMax)) {
					tp = roomContent_mc.attachMovie(wall+(index-wallMin), wall+n, n*depther);
					tp._x = (y-x)*(w)/2;
					tp._y = (x+y)*(h)/2-(tempWidth-h);
					tp.gotoAndStop(2);
				} else if ((index>stuffMin) && (index<stuffMax)) {
					tp = roomContent_mc.attachMovie(stuffLib+index, stuff+n, n*depther);
					tp._x = (y-x)*(w)/2;
					tp._y = (x+y)*(h)/2-(tempWidth-h);
				}
			}
		}
	}
}
